"""
Terms of Use
The following script is provided for your conveniece and is used at your
own discretion and risk. Digital Frontier is not responsible for any
damage to your computer system or loss of data that results from the
access, download and use of the content on this site.
"""

import sys
import math
import maya.OpenMaya as M
import maya.OpenMayaMPx as MPx
import maya.OpenMayaRender as MR
import maya.OpenMayaUI as MUI

kNodeName    = "DF_TALK_annotation"
kTypeID      = M.MTypeId(0x79998)
kNodeType    = MPx.MPxNode.kLocatorNode
gl = MR.MHardwareRenderer.theRenderer().glFunctionTable()

class baseLocator(MPx.MPxLocatorNode):
    size = M.MObject()
    def __init__(self):
        MPx.MPxLocatorNode.__init__(self)

    def draw(self, view, path, style, status):
        thisNode = self.thisMObject() 
        fnDAG = M.MFnDagNode(thisNode)
        
        plug = fnDAG.findPlug("text")
        
        view.beginGL()
        if(len(plug.asString()) != 0):
            view.drawText(plug.asString(), M.MPoint(0, 0, 0))
        else:
            view.drawText("DF_TALK_annotation", M.MPoint(0, 0, 0))
        view.endGL()

def baseLocatorCreator():
    return MPx.asMPxPtr(baseLocator())
    
def baseLocatorInitializer():
    nAttr = M.MFnTypedAttribute()
    baseLocator.size = nAttr.create( "text", "tx", M.MFnData.kString)
    nAttr.setStorable(1)
    nAttr.setWritable(1)

    baseLocator.addAttribute( baseLocator.size )

    return M.MStatus.kSuccess
 
def initializePlugin(obj):
    plugin = MPx.MFnPlugin(obj)
    plugin.registerNode(kNodeName, kTypeID, baseLocatorCreator, baseLocatorInitializer, kNodeType)

def uninitializePlugin(obj):
    plugin = MPx.MFnPlugin(obj)
    plugin.deregisterNode(kTypeID)